// ================================================================= //
//                                                                   //
//   File      : aw_status.hxx                                       //
//   Purpose   : Provide status related functions                    //
//                                                                   //
//   Coded by Ralf Westram (coder@reallysoft.de) in September 2010   //
//   Institute of Microbiology (Technical University Munich)         //
//   http://www.arb-home.de/                                         //
//                                                                   //
// ================================================================= //

#ifndef AW_STATUS_HXX
#define AW_STATUS_HXX

void aw_status_title(const char *text);    // set status title
void aw_status_subtitle(const char *text); // set statustext
void aw_status_gauge(double gauge);        // set progress bar

bool aw_status_aborted(); // return 1 if 'Abort' button has been pressed

// ---------------------
//      progress bar

void aw_openstatus(const char *title); // show status
void aw_closestatus();                 // hide status

// special for EDIT4 (obsolete - nobody listens to EDIT4-errors)
void aw_clear_message_cb(AW_window *aww);

#else
#error aw_status.hxx included twice
#endif // AW_STATUS_HXX
